//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * セグメント交差テスト実装
 * @author Junpee
 */

#include "Test/stdafx.h"
#include "Geometry/Intersection/SegmentIntersectionTest.h"

//------------------------------------------------------------------------------
// コンストラクタ
SegmentIntersectionTest::SegmentIntersectionTest(String name) :
	TestCase(name){
}
//------------------------------------------------------------------------------
// テストスィートの取得
Test* SegmentIntersectionTest::suite(){
	TestSuite* suite = new TestSuite("SegmentIntersectionTest");
	suite->addTest(new TestCaller(SegmentIntersectionTest, testPoint));
	suite->addTest(new TestCaller(SegmentIntersectionTest, testSegment));
	suite->addTest(new TestCaller(SegmentIntersectionTest, testSphere));
	suite->addTest(new TestCaller(SegmentIntersectionTest, testTriangle));
	return suite;
}
//------------------------------------------------------------------------------
// 点テスト
void SegmentIntersectionTest::testPoint(){
}
//------------------------------------------------------------------------------
// セグメントテスト
void SegmentIntersectionTest::testSegment(){
	Segment segment0(0.f, 0.f, 0.f, 0.f, 1.f, 0.f);
	Segment segment1(0.f, 2.f, 0.f, 0.f, 1.f, 0.f);
	TestAssert(!segment0.intersect(segment1));
	segment1.setOrigin(Vector3(1.f, 0.f, 0.f));
	TestAssert(!segment0.intersect(segment1));
	segment1.setDirection(Vector3(1.f, 0.f, 0.f));
	TestAssert(!segment0.intersect(segment1));
	segment1.setOrigin(Vector3(-1.f, 0.f, 0.f));
	TestAssert(segment0.intersect(segment1));
}
//------------------------------------------------------------------------------
// 球テスト
void SegmentIntersectionTest::testSphere(){
}
//------------------------------------------------------------------------------
// 三角テスト
void SegmentIntersectionTest::testTriangle(){
}
//------------------------------------------------------------------------------
